Help us understand the problem. What is going on with this article?

Tips:bashスクリプトでコマンドが失敗したら、エラーメールを飛ばす

More than 1 year has passed since last update.
hoge.sh
#!/bin/bash

NOTIFY_MAIL_TOS='who@dummy.co.jp'

function sendErrorMail() {
    local body="Error occurred."
    local subject="Error mail !!!"
    mail -s "${subject}" "${NOTIFY_MAIL_TOS}"
}

set -eu
trap "echo 'Error occurred.'; sendErrorMail; exit 1" ERR

## メインの処理

コマンドたち(「メインの処理」以降)で終了コード<>0が発生したときに、trapコマンドが発動してメールが送れます。

trapコマンドも'set -eu'も意外に使われていないことが多いですが、
プログラム(といってもbashスクリプトですが)を書く上でエラーハンドリングは、欠かせないので重宝しています。

'set -e'にしていても、trapコマンドが発動してくれるので、いい感じです。
大量に$?で終了コード判定をしなくても済むので、可読性も高くなります。

蛇足です。
・ おそらくたいていのbashバージョンで利用できると思います。
・ "trap ~~~ ERR"の"ERR"の部分については、シグナルについて確認してください。
・ シグナルの部分を変えると「ユーザーキャンセル時(Ctrl + C)は〇〇〇する」という制御できるようになります。

コメントなどありましたら、いただけると嬉しいです!!

rakus
「IT技術で中小企業を強くします!」というミッションを掲げ、中小企業の業務効率化に貢献する複数のクラウドサービスを提供しているIT企業です。「楽楽精算」「メールディーラー」など、国内トップシェアを誇る複数のサービスを開発し、累計導入社数は5万社を超えています。次の時代の"楽"を創るための、まだ見ぬサービスや機能を生み出す取り組みは、今日も続いています。
https://www.rakus.co.jp/
Why not register and get more from Qiita?
  1. We will deliver articles that match you
    By following users and tags, you can catch up information on technical fields that you are interested in as a whole
  2. you can read useful information later efficiently
    By "stocking" the articles you like, you can search right away
Comments
No comments
Sign up for free and join this conversation.
If you already have a Qiita account
Why do not you register as a user and use Qiita more conveniently?
You need to log in to use this function. Qiita can be used more conveniently after logging in.
You seem to be reading articles frequently this month. Qiita can be used more conveniently after logging in.
  1. We will deliver articles that match you
    By following users and tags, you can catch up information on technical fields that you are interested in as a whole
  2. you can read useful information later efficiently
    By "stocking" the articles you like, you can search right away
ユーザーは見つかりませんでした